import {select, csv, scaleLinear, scaleBand, max} from 'd3'

const svg = select('svg');
const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data => {
  const xValue = x => x.population;
	const yValue = y => y.country;
  const margin = {top:20, bottom:20, left:20, right:20};
  const innerWidth = width - margin.left - margin.right;
	const innerHeight = height - margin.top - margin.bottom;
  
  const xScale = scaleLinear()
  	.domain([0, max(data, xValue)]) // fixed syntax: 'a' represents each element form 'data'.
  	.range([0, innerWidth]);
  const yScale = scaleBand()
  	.domain(data.map(yValue))
  	.range([0, innerHeight]);
  
  const g = svg.append('g')
  	.attr('transform', `translate(${margin.left}, ${margin.top})`)
  g.selectAll('rect').data(data)
  	.enter().append('rect')
  		.attr('y', y=>yScale(yValue(y)))
  		.attr('width', x=>xScale(xValue(x)))//同样是语法糖,与9行使用形式相同
  		.attr('height', yScale.bandwidth())
};

csv('data.csv').then(data => {
  data.forEach(d => {
  	d.population = +d.populatio